namespace Syntriax.Engine.Core.Abstract;

/// <summary>
/// Represents an entity with a name.
/// </summary>
public interface INameable
{
    /// <summary>
    /// Event triggered when the name of the entity changes.
    /// </summary>
    event OnNameChangedEventHandler? OnNameChanged;

    /// <summary>
    /// The name of the entity.
    /// </summary>
    string Name { get; set; }

    delegate void OnNameChangedEventHandler(INameable sender, string previousName);
}
